
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm

#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);

void lcd_write_byte(unsigned char addr, unsigned char data);

unsigned char lcd_read_byte(unsigned char addr);

void lcd_gotoxy(unsigned char x, unsigned char y);

void lcd_clear(void);
void lcd_putchar(char c);

void lcd_puts(char *str);

void lcd_putsf(char flash *str);

unsigned char lcd_init(unsigned char lcd_columns);

void lcd_control (unsigned char control);

#pragma used-
#pragma library lcd.lib

char eeprom *ptr_to_eeprom;
unsigned char ticReadData=0; 

unsigned char flag=0;

flash unsigned char ConvertWinFont[]={0x41,0xA0,0x42,0xA1,0xE0,0x45,0xA3,0xA4,0xA5,0xA6,0x4B,0xA7,
0x4D,0x48,0x4F,0xA8,0x50,0x43,0x54,0xA9,0xAA,0x58,0xE1,0xAB,0xAC,0xE2,0xAD,0xAE,0x62,0xAF,0xB0,0xB1,
0x61,0xB2,0xB3,0xB4,0xE3,0x65,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0x6F,0xBE,0x70,0x63,0xBF,0x79,
0xE4,0x78,0xE5,0xC0,0xC1,0xE6,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7};

char DataBuff[280]={"                   "};
char *ptrDataBuff=&DataBuff[0];
char *ptrOutLCD_Buff=&DataBuff[0];

interrupt [12] void usartRX(void)
{
char data;

data=UDR;
flag |= 0x40;
if (flag & 0x80)
{
if (data==0x0A)
{

for (data=0; data<16; data++)
*ptrDataBuff++=0x20;   

*ptrDataBuff=0;
ptrDataBuff=&DataBuff[0];
ptr_to_eeprom=0;
ptr_to_eeprom+=0x0F;
*ptr_to_eeprom++=0;

while(*ptrDataBuff)
*ptr_to_eeprom++=*ptrDataBuff++; 

*ptr_to_eeprom=0;
ptrDataBuff=&DataBuff[0];
ptr_to_eeprom=0;
ptr_to_eeprom+=0x0F;
ptr_to_eeprom++;
ptrOutLCD_Buff=&DataBuff[0];
lcd_gotoxy(0,1);
lcd_putsf("                ");
flag &= ~0x40;
ticReadData=0;  
}
flag &= ~0x80;    
return;
}
if (data==0x0D)
{
flag |= 0x80;
return;
}
if (ticReadData < 255)
{
*ptrDataBuff=data;
ptrDataBuff++;
ticReadData++;
}
else     
flag &= ~0x80;
}

void beg_stroka(void)
{
unsigned char i;

for(i=0;i<17;i++)
lcd_write_byte(0xC0+i,lcd_read_byte(0xC1+i));

lcd_gotoxy(15,1);

switch (i=*ptrOutLCD_Buff)
{
case 168:
i=0xA2;
break;
case 184:
i=0xB5;
break;
default:
if (i>=192)
i=ConvertWinFont[i-192];
else
i=*ptrOutLCD_Buff;
}

lcd_putchar(i);
if(!(*(++ptrOutLCD_Buff)))
{
ptrOutLCD_Buff=&DataBuff[0];
if (!(flag & 0x20))
flag |= 0x20;
}
}

void init_AVR(void)
{

PORTB=0x00;
DDRB=0x00;

PORTC=0x00;
DDRC=0x00;

PORTD=0x00;
DDRD=0x00;

TCCR0=0x00;
TCNT0=0x00;

TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

MCUCR=0x00;

TIMSK=0x00;

UCSRA=0x00;
UCSRB=0x90;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x33;

ACSR=0x80;
SFIOR=0x00;
}

void main(void)
{

init_AVR();
lcd_init(16);   
lcd_gotoxy(0,0);
lcd_putsf("WINSTAR DISPLAYS");
#asm("sei")

while (1)
{
if (!(flag & 0x20))
break;

ptrOutLCD_Buff=&DataBuff[0];
ptr_to_eeprom=0;
ptr_to_eeprom+=0x0F;
if (!(*ptr_to_eeprom++))
{
while(*ptr_to_eeprom)
*ptrOutLCD_Buff++=*ptr_to_eeprom++;
*ptrOutLCD_Buff=0;
ptrOutLCD_Buff=&DataBuff[0];
ptr_to_eeprom=0;
ptr_to_eeprom+=0x0F;
ptr_to_eeprom++;
}
break;
}

while (1)
{
while (flag & 0x40);
if (!(flag & 0x10))
{
if (flag & 0x20)
{
flag |= 0x10;
ptrOutLCD_Buff=&DataBuff[0];
ptr_to_eeprom=0;
ptr_to_eeprom+=0x0F;
if (!(*ptr_to_eeprom++))
{
while(*ptr_to_eeprom)
*ptrOutLCD_Buff++=*ptr_to_eeprom++;
*ptrOutLCD_Buff=0;
ptrOutLCD_Buff=&DataBuff[0];
ptr_to_eeprom=0;
ptr_to_eeprom+=0x0F;
ptr_to_eeprom++;
}
}
}
delay_ms(400		);
beg_stroka();
}
}
